// transformations
float4x4 World : register(c0);
float4x4 View : register(c4);
float4x4 Proj : register(c8);

#include "dcLighting.HLSL"

struct VS_OUTPUT{
    float4 Pos				: POSITION;
    float4 Diffuse			: COLOR0;
	float2 Tex              : TEXCOORD0;
};

struct VS_INPUT{
    float3 Pos              : POSITION;
	float3 Normal			: NORMAL;
    float2 Tex              : TEXCOORD0;
};

VS_OUTPUT main(const VS_INPUT Input){
	float3 Pos = mul(float4(Input.Pos, 1), World);
	float3 Normal = mul(Input.Normal, (float3x3)World);

	Pos = mul(float4(Pos, 1), (float4x3)View);

	float4 Diffuse = ComputeDiffuse(Pos, Normal);

	VS_OUTPUT Out;
    Out.Pos = mul(float4(Pos, 1), Proj);
	Out.Diffuse = Diffuse;
	Out.Tex = Input.Tex;
    return Out;
}